Release: 1

Summary: A research tool for real time image processing experimentation.
Name: improvqt
Version: 5.1
Copyright: GPL
Group: Applications/Multimedia
Source: http://robotics.ee.uwa.edu.au/improv/ftp/improvqt-%{version}.tar.gz
#Patch: improv-5.1-buildroot.patch
BuildRoot: /var/tmp/%{name}-%{version}-root
Requires: qt >= 3.0.0
Prefix: ${prefix}

%description
Improv is a tool for basic real time image processing with 
low resolution, e.g. suitable for mobile robots. Improv 
works with a number of inexpensive low-resolution digital 
cameras (no framegrabber required).

%package devel
Summary: A research tool for real time image processing experimentation.
Group: Applications/Multimedia
Requires: %{name} = ${version}

%description devel
This package contains the files required for developing
image processing plugins for Improv.

%prep

%setup

%build
./configure --host=%{_host} --build=%{_build} --prefix=%{_prefix} --exec-prefix=%{_exec_prefix} --bindir=%{_bindir} --sbindir=%{_sbindir} --sysconfdir=%{_sysconfdir} --datadir=%{_datadir} --includedir=%{_includedir} --libdir=%{_libdir} --libexecdir=%{_libexecdir} --mandir=%{_mandir} --infodir=%{_infodir} --enable-mt

if [ -d $RPM_BUILD_ROOT ]; then rm -r $RPM_BUILD_ROOT; fi;
mkdir -p $RPM_BUILD_ROOT%{prefix}
make RPM_OPT_FLAGS="$RPM_OPT_FLAGS"

%install
#if [ -d $RPM_BUILD_ROOT ]; then rm -r $RPM_BUILD_ROOT; fi;
#mkdir -p $RPM_BUILD_ROOT%{prefix}
#make install
make DESTDIR=$RPM_BUILD_ROOT prefix=%{prefix} install

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc AUTHORS README INSTALL TODO COPYING ChangeLog
%{_bindir}/*
%{_sysconfdir}/improvqt.conf
%{_libdir}/libFW.so*
%{_libdir}/improv-%{version}/lib*_plugin.so

%files devel
%defattr(-,root,root)
%{_includedir}/improv_plugin.h
%{_includedir}/FW/*.h
%{_libdir}/libFW.la
%{_libdir}/improv-%{version}/lib*_plugin.la

%changelog
* Sun Mar 30 2003 Leon Koch <leon@redfishsoftware.com.au>
- Created improvqt.spec.in

* Thu Oct 31 2002 Leon Koch <leon@redfishsoftware.com.au>
- RPM Build of Improv 5.1
- Lots of changes.

* Sun Sep 15 2002 Leon Koch <leon@redfishsoftware.com.au> 
- RPM Build of the all new Improv 5.0

