/* ImprovQTView.h
 * Last modified: 
 * Authors: Daniel Venkitachalam <venki-d@ee.uwa.edu.au>
 *          Leon Koch <leon@redfishsoftware.com.au>
 */
/** @class ImprovQTView
 * This class provides the application view.
 */

#ifndef IMPROVQTVIEW_H
#define IMPROVQTVIEW_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

// QT includes
#include <qwidget.h>
#include <qimage.h>
#include <qpixmap.h>
#include <qscrollview.h>
#include <qlayout.h>
#include <qhbox.h>
#include <qvbox.h>
#include <qgrid.h>
#include <qframe.h>
#include <qsize.h>

class ImprovQTView : public QWidget
{
	Q_OBJECT
	public:
		/** Constructor. */
		ImprovQTView(QWidget *parent=0);
		/** Destructor. Deletes the instance of the class. */
		~ImprovQTView();

		/** */
		void redraw(void);
		/** */
		void reload(void);
		
	private:
		//QScrollView *effectView;
		//QHBox *effectHBox;
		//QGrid *grid;
		/** */
		QGridLayout *effectGridLayout;
		//QVBox *vbox;
		//QVBoxLayout *vlayout1;
		//QFrame *frame;

	protected slots:
		/** */
		void slotDocumentChanged();

};

#endif
